--
-- Copyright(C) 2007-2008 Shimafuji Electric Inc. All Rights reserved.
--
-- Shimafuji Electric Inc. grants permission to use, copy, redistribute and/or modify
-- this souce file or products generated by this source file without restriction
-- provided that above copyright statement, this list of conditions and the following
-- disclaimer is preserved and that any derivative work contains the original
-- copyright notice.
-- This source file is distributed WITHOUT ANY WARRANTY, without even the implied
-- warranty of merchantability or fitness for a particular purpose.
-- By providing this source file Shimafuji Electric Inc. making no representation
-- that this source file or products generated by this source file is free from
-- any claims of infringement.
--

----------------------------------------------------------------------------------
-- SpaceWire host interface for RMAP logic
----------------------------------------------------------------------------------
--
-- 2008/05/28 Error recoveryǉ
-- @ErrorResetApPbgMEOP܂MĂȂƂRXFIFOEEPǉ
-- @ErrorResetApPbgMEOP܂ĂȂƂEOP܂TXFIFOǂ݂
--  linkI/FԂfifo_preparedMǉ
--  ErrorReset TXFIFO,RXFIFONA鏈폜
--
--IP-Rev1.04
--2011/04/06 rx_fifo_emptyOֈo悤ɕύXB
--


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Xilinx primitives is used in this code.
library UNISIM;
use UNISIM.VComponents.all;


entity spw_if is
    port (
		clk : in std_logic;
		tx_clk : in std_logic;
		rx_clk : in std_logic;
		reset : in std_logic;
		
		tx_fifo_we : in std_logic;
		tx_fifo_data_in : in std_logic_vector (8 downto 0);
		tx_fifo_full : out std_logic;
		tx_fifo_data_num : out std_logic_vector (5 downto 0);
		rx_fifo_oe : in std_logic;
		rx_fifo_data_out : out std_logic_vector (8 downto 0);
		rx_fifo_full : out std_logic;
		rx_fifo_empty : out std_logic;	--2011/04/06 added 
		rx_fifo_data_num : out std_logic_vector (5 downto 0);
		
		tick_in : in std_logic;
		time_in : in std_logic_vector (5 downto 0);
		control_flags_in : in std_logic_vector (1 downto 0);
		tick_out : out std_logic;
		time_out : out std_logic_vector (5 downto 0);
		control_flags_out : out std_logic_vector (1 downto 0);
		
		link_start : in std_logic;
		link_disable : in std_logic;
		auto_start : in std_logic;
		link_status : out std_logic_vector (7 downto 0);
		error_status : out std_logic_vector (7 downto 0);
		txclk_sel : in std_logic_vector (5 downto 0);
		credit_count : out std_logic_vector (5 downto 0);
		outstanding_count : out std_logic_vector (5 downto 0);
		TCsent : out std_logic;   -- Inoue modified
		
		dout : out std_logic;
		sout : out std_logic;
		din : in std_logic;
		sin : in std_logic
	);
end spw_if;

architecture Behavioral of spw_if is

	component fifo9x64 IS
		port (
	din: IN std_logic_VECTOR(8 downto 0);
	rd_clk: IN std_logic;
	rd_en: IN std_logic;
	rst: IN std_logic;
	wr_clk: IN std_logic;
	wr_en: IN std_logic;
	dout: OUT std_logic_VECTOR(8 downto 0);
	empty: OUT std_logic;
	full: OUT std_logic;
	rd_data_count: OUT std_logic_VECTOR(5 downto 0));
	END component;

	component spw_link_if is
		port (
			clock: in std_logic;
			reset: in std_logic;
			-- state machine
			tx_clock: in std_logic;
			link_start: in std_logic;
			link_disable: in std_logic;
			auto_start: in std_logic;
			link_status : out std_logic_vector (7 downto 0);
			error_status : out std_logic_vector (7 downto 0);
			reset_out : out std_logic;
			fifo_prepared : in std_logic;
			TCsent : out std_logic;   -- Inoue modified
			-- transmitter
			tick_in: in std_logic;
			time_in: in std_logic_vector (5 downto 0);
			control_flags_in: in std_logic_vector (1 downto 0);
			tx_write: in std_logic;
			tx_data: in std_logic_vector (7 downto 0);
			tx_control_flag: in std_logic;
			tx_ready: out std_logic;
			txclk_sel: in std_logic_vector (5 downto 0);
			credit_count : out std_logic_vector (5 downto 0);
			outstanding_count : out std_logic_vector (5 downto 0);
			-- receiver
			rx_clock: in std_logic;
			ds_clock: out std_logic;
			tick_out: out std_logic;
			time_out: out std_logic_vector (5 downto 0);
			control_flags_out: out std_logic_vector (1 downto 0);
			buffer_write: out std_logic;
			rx_data: out std_logic_vector (7 downto 0);
			rx_control_flag: out std_logic;
			buffer_ready: in std_logic;
			rx_fifo_count : in std_logic_vector(5 downto 0);
			-- serial i/o
			dout: out std_logic;
			sout: out std_logic;
			din: in std_logic;
			sin: in std_logic
		);
	end component;
	
	component sync_one_pulse is
		port (
			clk : in std_logic;
			reset : in std_logic;
			async_in : in std_logic;
			sync_out : out std_logic
		);
	end component;
	
	signal tx_started : std_logic;
	signal tx_started_sync : std_logic;
	
	--signal link_start: std_logic;
	--signal link_disable: std_logic;
	--signal auto_start: std_logic;
	--signal link_status : std_logic_vector (7 downto 0);
	--signal error_status : std_logic_vector (7 downto 0);
	
	type txws is (
		TXW_IDLE,
		TXW_WRITE0,
		TXW_WRITE1,
		TXW_RESET0,
		TXW_RESET1,
		TXW_RESET2
	);
	signal tx_wr_state : txws;
	
	-- transmitter
	signal tx_write: std_logic;
	signal tx_data: std_logic_vector (7 downto 0);
	signal tx_control_flag: std_logic;
	signal tx_ready: std_logic;
	-- receiver
	signal ds_clock: std_logic;
	signal buffer_write: std_logic;
	signal rx_data: std_logic_vector (7 downto 0);
	signal rx_control_flag: std_logic;
	signal buffer_ready: std_logic;
	signal rx_fifo_full_buf : std_logic;
	signal rx_fifo_count : std_logic_vector(5 downto 0);
	
	signal tx_fifo_ren : std_logic;
	signal tx_fifo_empty : std_logic;
	signal tx_fifo_rdata : std_logic_vector (8 downto 0);
	signal rx_fifo_wdata : std_logic_vector (8 downto 0);
	signal rx_fifo_wen : std_logic;
	signal fifo_reset : std_logic;
	
	signal reset_out : std_logic;
	
	signal reset_rx_fifo : std_logic;
	signal middle_of_tx_packet : std_logic;
	signal middle_of_rx_packet : std_logic;
	signal middle_of_rx_packet_sync : std_logic;
	signal fifo_prepared : std_logic;
	signal buffer_write_eep : std_logic;
	
	signal tx_clk_sel : std_logic_vector (1 downto 0);

begin

	tx_data <= tx_fifo_rdata (7 downto 0);
	tx_control_flag <= tx_fifo_rdata (8);
	
	fifo_reset <= reset;
	
	tx_fifo : fifo9x64
		port map (
			rd_clk	=> clk,	--tx_clock,
			rd_en	=> tx_fifo_ren,
			dout	=> tx_fifo_rdata,
			wr_clk	=> clk,
			wr_en	=> tx_fifo_we,
			din		=> tx_fifo_data_in,
			empty	=> tx_fifo_empty,
			full	=> tx_fifo_full,
			rd_data_count => tx_fifo_data_num,
			rst		=> fifo_reset
		);
	
	rx_fifo_wdata <= "100000001" when buffer_write_eep = '1' else rx_control_flag & rx_data;
	rx_fifo_wen <= buffer_write or buffer_write_eep;
	rx_fifo_data_num <= rx_fifo_count;
	
	rx_fifo : fifo9x64
		port map (
			rd_clk	=> clk,
			rd_en	=> rx_fifo_oe,
			dout	=> rx_fifo_data_out,
			wr_clk	=> rx_clk,
			wr_en	=> rx_fifo_wen,
			din		=> rx_fifo_wdata,
			empty => rx_fifo_empty,	--2011/04/06 added
			full	=> rx_fifo_full_buf,
			rd_data_count => rx_fifo_count,
			rst		=> fifo_reset
		);
	
	process (rx_clk, reset)
	begin
		if (reset = '1') then
			middle_of_rx_packet <= '0';
			buffer_write_eep <= '0';
			reset_rx_fifo <= '0';
		elsif (rx_clk'event and rx_clk = '1') then
			-- synchronize
			if (reset_out = '1') then reset_rx_fifo <= '1';
			else reset_rx_fifo <= '0';
			end if;
			
			if (reset_rx_fifo = '1') then
				if (middle_of_rx_packet = '1') then
					middle_of_rx_packet <= '0';
					buffer_write_eep <= '1';
				else
					buffer_write_eep <= '0';
				end if;
			elsif (buffer_write = '1') then
				if (rx_fifo_wdata (8) = '1') then
					middle_of_rx_packet <= '0';
				else
					middle_of_rx_packet <= '1';
				end if;
			end if;
		end if;
	end process;
	
	buffer_ready <= not rx_fifo_full_buf;
	rx_fifo_full <= rx_fifo_full_buf;
	
	tx_started <= not tx_ready;
	tx_rdy_pulse : sync_one_pulse
	port map (
		clk => clk,
		reset => reset,
		async_in => tx_started,
		sync_out => tx_started_sync
	);
	
	process (clk, reset)
	begin
		if (reset = '1') then
			tx_write <= '0';
			tx_fifo_ren <= '0';
			middle_of_tx_packet <= '0';
			tx_wr_state <= TXW_IDLE;
			
		elsif (clk'event and clk = '1') then
			if (tx_wr_state = TXW_IDLE) then
				if (reset_out = '1' and middle_of_tx_packet = '1') then
					tx_wr_state <= TXW_RESET0;
				else
					--if (tx_fifo_data_num /= "000000" and tx_ready = '1') then
					if (tx_fifo_empty = '0' and tx_ready = '1') then
						tx_fifo_ren <= '1';
						tx_wr_state <= TXW_WRITE0;
					end if;
				end if;
				
			elsif (tx_wr_state = TXW_WRITE0) then
				tx_write <= '1';
				tx_fifo_ren <= '0';
				tx_wr_state <= TXW_WRITE1;
				
			elsif (tx_wr_state = TXW_WRITE1) then
				tx_write <= '0';
				if (reset_out = '1') then
					if (tx_fifo_rdata (8) = '1') then
						middle_of_tx_packet <= '0';
						tx_wr_state <= TXW_IDLE;
					else
						middle_of_tx_packet <= '1';
						tx_wr_state <= TXW_RESET0;
					end if;
				else
					if (tx_started_sync = '1') then
						if (tx_fifo_rdata (8) = '1') then
							middle_of_tx_packet <= '0';
						else
							middle_of_tx_packet <= '1';
						end if;
						tx_wr_state <= TXW_IDLE;
					end if;
				end if;
			
			elsif (tx_wr_state = TXW_RESET0) then
				if (tx_fifo_empty = '0') then
					tx_fifo_ren <= '1';
					tx_wr_state <= TXW_RESET1;
				end if;
			elsif (tx_wr_state = TXW_RESET1) then
				tx_fifo_ren <= '0';
				tx_wr_state <= TXW_RESET2;
			
			elsif (tx_wr_state = TXW_RESET2) then
				if (tx_fifo_rdata (8) = '1') then
					middle_of_tx_packet <= '0';
					tx_wr_state <= TXW_IDLE;
				else
					middle_of_tx_packet <= '1';
					tx_wr_state <= TXW_RESET0;
				end if;
			
			end if;
		end if;
	
	end process;
	
	process (clk, reset) begin
		if (reset = '1') then middle_of_rx_packet_sync <= '0';
		elsif (clk'event and clk = '1') then
			if (middle_of_rx_packet = '1') then middle_of_rx_packet_sync <= '1';
			else middle_of_rx_packet_sync <= '0';
			end if;
		end if;
	end process;
	
	fifo_prepared <= '0' when (middle_of_tx_packet = '1' or middle_of_rx_packet_sync = '1') else '1';
	
	
	sio0 : spw_link_if
		port map (
			clock => clk,
			reset => reset,
			-- state machine
			tx_clock => tx_clk,
			link_start => link_start,
			link_disable => link_disable,
			auto_start => auto_start,
			link_status => link_status,
			error_status => error_status,
			reset_out => reset_out,
			fifo_prepared => fifo_prepared,
			-- transmitter
			tick_in => tick_in,
			time_in => time_in,
			control_flags_in => control_flags_in,
			tx_write => tx_write,
			tx_data => tx_data,
			tx_control_flag => tx_control_flag,
			tx_ready => tx_ready,
			txclk_sel => txclk_sel,
			credit_count => credit_count,
			outstanding_count => outstanding_count,
			TCsent => TCsent,   -- Inoue modified
			-- receiver
			rx_clock => rx_clk,
			ds_clock => ds_clock,
			tick_out => tick_out,
			time_out => time_out,
			control_flags_out => control_flags_out,
			buffer_write => buffer_write,
			rx_data => rx_data,
			rx_control_flag => rx_control_flag,
			buffer_ready => buffer_ready,
			rx_fifo_count => rx_fifo_count,
			-- serial i/o
			dout => dout,
			sout => sout,
			din => din,
			sin => sin
		);
	
	
end Behavioral;

