--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:06:05 01/07/2009
-- Design Name:   
-- Module Name:   C:/spc/20080926_Shimafuji_IPCore_NoRouter_0818modified/SpaceCube_SpaceWireFPGA/spc_fpga/spw_digital_io_spwfpga/testbencg_of_timecode.vhdl
-- Project Name:  spw_digital_io_spwfpga
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: spw_fpga_dio
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY testbencg_of_timecode IS
END testbencg_of_timecode;
 
ARCHITECTURE behavior OF testbencg_of_timecode IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT spw_fpga_dio
    PORT(
         clk : IN  std_logic;
         reset_n : IN  std_logic;
         din : IN  std_logic;
         sin : IN  std_logic;
         dout : OUT  std_logic;
         sout : OUT  std_logic;
         ebus_adr : INOUT  std_logic_vector(24 downto 0);
         ebus_d : INOUT  std_logic_vector(15 downto 0);
         ebus_ena : INOUT  std_logic;
         ebus_wrn : INOUT  std_logic;
         ebus_rdn : INOUT  std_logic;
         ebus_req : IN  std_logic;
         ebus_grant : OUT  std_logic;
         ebus_done : INOUT  std_logic;
         cko : OUT  std_logic;
         cke : OUT  std_logic;
         ceb : OUT  std_logic;
         rasb : OUT  std_logic;
         casb : OUT  std_logic;
         web : OUT  std_logic;
         dm : OUT  std_logic;
         addr : OUT  std_logic_vector(12 downto 0);
         ba : OUT  std_logic_vector(1 downto 0);
         dq : INOUT  std_logic_vector(7 downto 0);
         led_out : OUT  std_logic_vector(3 downto 0);
         test : OUT  std_logic_vector(3 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
	signal clk100 : std_logic := '0';
   signal reset_n : std_logic := '0';
   signal din : std_logic := '0';
   signal sin : std_logic := '0';
   signal ebus_req_a : std_logic := '0';
   signal ebus_req_b : std_logic := '0';

	--BiDirs
   signal ebus_adr_a : std_logic_vector(24 downto 0) := (others => '0');
   signal ebus_d_a : std_logic_vector(15 downto 0) := (others => '0');
   signal ebus_ena_a : std_logic := '0';
   signal ebus_wrn_a : std_logic := '0';
   signal ebus_rdn_a : std_logic := '0';
   signal ebus_done_a : std_logic := '0';
   signal ebus_adr_b : std_logic_vector(24 downto 0) := (others => '0');
   signal ebus_d_b : std_logic_vector(15 downto 0) := (others => '0');
   signal ebus_ena_b : std_logic := '0';
   signal ebus_wrn_b : std_logic := '0';
   signal ebus_rdn_b : std_logic := '0';
   signal ebus_done_b : std_logic := '0';
   signal dq_a : std_logic_vector(7 downto 0) := (others => '0');
   signal dq_b : std_logic_vector(7 downto 0) := (others => '0');

 	--Outputs
   signal dout : std_logic := '0';
   signal sout : std_logic := '0';
   signal ebus_grant_a : std_logic := '0';
   signal ebus_grant_b : std_logic := '0';
   signal cko : std_logic := '0';
   signal cke : std_logic := '0';
   signal ceb : std_logic := '0';
   signal rasb : std_logic := '0';
   signal casb : std_logic := '0';
   signal web : std_logic := '0';
   signal dm : std_logic := '0';
   signal addr : std_logic_vector(12 downto 0) := (others => '0');
   signal ba : std_logic_vector(1 downto 0) := (others => '0');
   signal led_out_a : std_logic_vector(3 downto 0) := (others => '0');
   signal test_a : std_logic_vector(3 downto 0) := (others => '0');
   signal led_out_b : std_logic_vector(3 downto 0) := (others => '0');
   signal test_b : std_logic_vector(3 downto 0) := (others => '0');

   -- Clock period definitions
   constant clk_period : time := 20ns;
	constant clk100_period : time := 10ns;
	constant TC_period : time := 1us;
	
	signal count : integer :=0;
	signal TCclock : std_logic := '0';
	signal TCcount : std_logic_vector(7 downto 0) := "00000011";
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut_a: spw_fpga_dio PORT MAP (
          clk => clk,
          reset_n => reset_n,
          din => din,
          sin => sin,
          dout => dout,
          sout => sout,
          ebus_adr => ebus_adr_a,
          ebus_d => ebus_d_a,
          ebus_ena => ebus_ena_a,
          ebus_wrn => ebus_wrn_a,
          ebus_rdn => ebus_rdn_a,
          ebus_req => ebus_req_a,
          ebus_grant => ebus_grant_a,
          ebus_done => ebus_done_a,
          cko => cko,
          cke => cke,
          ceb => ceb,
          rasb => rasb,
          casb => casb,
          web => web,
          dm => dm,
          addr => addr,
          ba => ba,
          dq => dq_a,
          led_out => led_out_a,
          test => test_a
        );

   uut_b: spw_fpga_dio PORT MAP (
          clk => clk,
          reset_n => reset_n,
          din => dout,
          sin => sout,
          dout => din,
          sout => sin,
          ebus_adr => ebus_adr_b,
          ebus_d => ebus_d_b,
          ebus_ena => ebus_ena_b,
          ebus_wrn => ebus_wrn_b,
          ebus_rdn => ebus_rdn_b,
          ebus_req => ebus_req_b,
          ebus_grant => ebus_grant_b,
          ebus_done => ebus_done_b,
          cko => open,
          cke => open,
          ceb => open,
          rasb => open,
          casb => open,
          web => open,
          dm => open,
          addr => open,
          ba => open,
          dq => dq_b,
          led_out => led_out_b,
          test => test_b
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;

   clk100_process :process
   begin
		clk100 <= '0';
		wait for clk100_period/2;
		clk100 <= '1';
		wait for clk100_period/2;
   end process;
	
	TCclock_process :process
	begin
		TCclock <= '0';
		wait for TC_period/2;
		TCclock <= '1';
		wait for TC_period/2;
	end process;
	
	reset_n <= '1'; --always no reset
	
	timecode_process : process (TCclock, clk)
	begin
		if(TCclock'event and TCclock='1')then
			TCcount <= TCcount + '1';
			ebus_done_a <= '1';
			ebus_d_a(15 downto 8) <= TCcount;
		end if;
		if(clk'event and clk='1')then
			ebus_done_a <= '0';
		end if;
	end process;
	
--	stimulous_process : process (clk100)
--	begin
--		if(clk100'event and clk100='1')then
--			count <= count + 1;
--			case count is
--				when 3500 =>
--					ebus_done_a <= '1';
--					ebus_d_a(15 downto 8) <= "00000011";
--				when 3510 =>
--					ebus_done_a <= '0';
--				when 3520 =>
--					ebus_done_a <= '1';
--					ebus_d_a(15 downto 8) <= "00000100";
--				when 3530 =>
--					ebus_done_a <= '0';
--				when others =>
--				
--			end case;
--		end if;
--	end process;

END;
